package ec.edu.epn.consumosriautorizacion.service;

import ec.edu.epn.consumosriautorizacion.dto.DetallefacturaDTO;
import ec.edu.epn.consumosriautorizacion.dto.FacturaDTO;
import ec.edu.epn.consumosriautorizacion.dto.PagosDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.io.*;
import org.springframework.mail.SimpleMailMessage;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.JavaMailSenderImpl;
import org.springframework.mail.javamail.MimeMessageHelper;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.activation.DataSource;
import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;
import javax.mail.util.ByteArrayDataSource;
import java.io.*;
import java.util.List;
import java.util.Properties;

@Service
public class EmailService {
    @Autowired
    private JavaMailSender javaMailSender;




    @Async
    public void sendEmail(List<String> to, String subject, String text, String attachment, String idFactura) {
        try {
            JavaMailSenderImpl javaMailSender = new JavaMailSenderImpl();
            javaMailSender.setHost("smtp.office365.com");
            javaMailSender.setPort(587);
            javaMailSender.setUsername("facturacion.electronica@epn.edu.ec");
            javaMailSender.setPassword("Epndgip2023*$");
            Properties props = javaMailSender.getJavaMailProperties();
            props.put("mail.transport.protocol", "smtp");
            props.put("mail.smtp.auth", "true");
            props.put("mail.smtp.starttls.enable", "true");
            props.put("mail.debug", "true");



            MimeMessage mimeMessage = javaMailSender.createMimeMessage();
            MimeMessageHelper messageHelper = new MimeMessageHelper(mimeMessage, true, "utf-8");
            mimeMessage.setContent(text.toString(), "text/html;charset=utf-8");
            messageHelper.setTo(to.toArray(new String[to.size()]));
            messageHelper.setFrom("facturacion.electronica@epn.edu.ec");
            messageHelper.setSubject(subject);


            //// AGREGAR FACTURA PARA ENVIO

            if(!attachment.equals("")){
                System.out.println("ARCHIVOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO" + attachment);

                File initialFile = new File(attachment);
                InputStream targetStream = new FileInputStream(initialFile);
                DataSource content = new ByteArrayDataSource(targetStream, "application/octet-stream");
                messageHelper.addAttachment("pruebas.pdf",
                        content);
                javaMailSender.send(mimeMessage);
                System.out.printf("SEND MAILIN PE..");
            }
            





            javaMailSender.send(mimeMessage);

        }catch(Exception e){
            e.getMessage();
        }

    }





    public String remplazarCaracteresHTML(String valor) {
        try {
            String A = "&#193;";
            String E = "&#201;";
            String I = "&#205;";
            String O = "&#211;";
            String U = "&#218;";
            String a = "&#225;";
            String e = "&#233;";
            String i = "&#237;";
            String o = "&#243;";
            String u = "&#250;";
            String Ñ = "&#209;";
            String ñ = "&#241;";

            valor = valor.replace("á", a).replace("é", e).replace("í", i).replace("ó", o).replace("ú", u)
                    .replace("Á", A).replace("É", E);
            valor = valor.replace("Í", I).replace("Ó", O).replace("Ú", U).replace("Ñ", Ñ).replace("ñ", ñ);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return valor;
    }
}
