package ec.edu.epn.consumosriautorizacion.service;


import ec.edu.epn.consumosriautorizacion.exceptions.FTPErrors;
import org.springframework.stereotype.Service;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;

@Service
public interface FTPService {
    void connectToFTP() throws FTPErrors, FTPErrors;

    void uploadFileToFTP(BufferedInputStream input, String ftpHostDir, String serverFilename) throws FTPErrors;

    void downloadFileFromFTP(String ftpRelativePath, String copytoPath) throws FTPErrors;

    void disconnectFTP() throws FTPErrors;

    byte[] downFileByte(String remotePath, String fileName) throws FTPErrors, IOException;

}
