package ec.edu.epn.consumosriautorizacion.Tasks;

import ec.edu.epn.consumosriautorizacion.service.FTPService;
import org.springframework.batch.core.StepContribution;
import org.springframework.batch.core.scope.context.ChunkContext;
import org.springframework.batch.core.step.tasklet.Tasklet;
import org.springframework.batch.repeat.RepeatStatus;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;

import java.util.ArrayList;
import java.util.List;


@Component
public class Task_Ftp implements Tasklet {


    private FTPService ftpService;
    @Override
    public RepeatStatus execute(StepContribution contribution, ChunkContext chunkContext) throws Exception {
        ftpService.connectToFTP();

        //TODO: se deben obtener el path remoto de las facturas a enviar
        String pathFtp = "/facturas/";

        //TODO: añadir el listado de los archivos ftp en multipart para el envio

        List<MultipartFile> files = new ArrayList<>();
        List<String> fileNames = new ArrayList<>();
        for (MultipartFile file : files) {
            String fileName = file.getOriginalFilename();
          //  ftpService.uploadFileToFTP(file.getInputStream(), pathFtp, fileName);
            fileNames.add(fileName);
        }
        ftpService.disconnectFTP();



        return  RepeatStatus.FINISHED;
    }
}